package com.eactive.eai.batch.job.jobItem.cms25;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.osd.OutsideManager;
import com.eactive.eai.batch.osd.OutsideVO;
import com.eactive.eai.batch.rule.dirInfo.BatchJobInfoVO;
import com.eactive.eai.batch.rule.dirInfo.DirInfoManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_CMS25_0640 extends DefaultTelegram implements TelegramService
{
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    /**
     * 생성자
     */
    public SEND_CMS25_0640() {
        //화일정보수신통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //업무구분코드 - 센터 및 은행에서 업무구분을 위하여 SET
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);
            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            //거래구분코드 "R"-센터 수신 업무, "S"-센터 송신업무
            //compileField(5, this.getFldTrClass(), this.al_FieldProps[5]);
            //기관별로 송수신시 사용되는 거래구분코드가 상이하여 기관별 속성값에서 참조하도록 함.
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
                 procType.equalsIgnoreCase(CommonKeys.PROCESS_RESPONSE_SEND)) {
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_SEND), this.al_FieldProps[5]);
            }else{
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_RECV), this.al_FieldProps[5]);
            }
            //송수신 FLAG "C"-센터에서 전문을 발생할 시, "B"-은행에서 전문을 발생할 시
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
                 procType.equalsIgnoreCase(CommonKeys.PROCESS_RESPONSE_SEND)) {
                compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_SEND), this.al_FieldProps[6]);
            }else{
                compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_RECV), this.al_FieldProps[6]);
            }
            //화일명
            compileField(7, batchDoc.getBatchMsg().getHeader().getFileName() , this.al_FieldProps[7]);
            //응답코드
            compileField(8, this.getSendResponseCode(), this.al_FieldProps[8]);
            //화일 정보내역. 화일명+화일size+전문바이트수
            //RECV 0630/0640에서는 서로 교환한 값중 작은 값으로 결정한다.
            StringBuffer fileInfo = new StringBuffer();
            fileInfo.append(makeSpace(batchDoc.getBatchMsg().getHeader().getFileName(), getCalculatedLength(7)));
            fileInfo.append(makeZero(""+batchDoc.getBatchMsg().getBody().getCurFileSize(),12));
            fileInfo.append(makeZero(""+calculateTelegramSize(), 4));
            compileField(9, fileInfo.toString(), this.al_FieldProps[9]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            //해당 거래구분에 대한 Job_Code 값 설정
            //거래구분코드 조회 BizCode 조회
            int bizCodeStartIndex = 0;
            int bizCodeEndIndex   = 0;
            String fileName = batchDoc.getBatchMsg().getHeader().getFileName();
            ArrayList<OutsideVO> organList = OutsideManager.getInstance().getOutsideInfo(batchDoc.getBatchMsg().getHeader().getProcessCode());
            for (int i=0; organList!=null && i<organList.size(); i++) {
              OutsideVO organInfo = organList.get(i);
              if ( batchDoc.getBatchMsg().getHeader().getInstitutionCode().equals(organInfo.getOsdCode()) ) {
                bizCodeStartIndex = organInfo.getBizCdStartIdx();
                bizCodeEndIndex   = organInfo.getBizCdEndIdx();
                break;
              }
            }
            if (bizCodeStartIndex <= 0 || bizCodeStartIndex >= fileName.length()) bizCodeStartIndex = 0;
            if (bizCodeEndIndex   <= 0 || bizCodeEndIndex   >  fileName.length()) bizCodeEndIndex = fileName.length();
            String bizCode = fileName.substring(bizCodeStartIndex, bizCodeEndIndex);

            BatchJobInfoVO info = DirInfoManager.getInstance().getFileInfoByDstcd(batchDoc.getBatchMsg().getHeader().getProcessCode(), bizCode);
            if (info != null) {
                batchDoc.getBatchMsg().getHeader().setJobCode(info.getMsgDstCode());;
            } else {
            	logger.debug("{} " +  batchDoc.getBatchMsg().getHeader().getUUID()+ "'s Job Code is null", logHeader);
                String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
                batchDoc.getBatchMsg().getHeader().setJobCode((processCode+"00000"));   //dummy code
                // TEST 용 return false;
            }
            try {
				int sleepTime = Integer.parseInt(telegramInfo.getProperty(TelegramKeys.SLEEP_TIME));
				Thread.sleep(sleepTime); 
			} catch (Exception e) {}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            //성공 시 응답수신 파일 Start DB로그
            if (this.getSendResponseCode().equals(TelegramKeys.RES_CODE_SUCESS)){
                LogUtil.setLogFileStart(batchDoc);
            }

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // XX인 경우 길이를 1로 계산하므로 i=3 인 경우 실제 기관 코드 사용 길이-1 만큼을 더 해 준다.
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += ( getCalculatedLength(1) - 1 );
            SEND_LENGTH += ( getCalculatedLength(3) - 1 );
            SEND_LENGTH += ( getCalculatedLength(7) - 1 );
            SEND_LENGTH += ( getCalculatedLength(9) - 1 );
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int fieldLen = -1;
        String propKey = "";
        switch (idx) {

        case 1:
            propKey = TelegramKeys.TRCD_LEN;
            break;

        case 3:
            propKey = TelegramKeys.ORGN_CD_LEN;
            break;

        case 7:
            propKey = TelegramKeys.FILE_NAME_LEN;
            break;

        case 9:
            propKey = TelegramKeys.FILE_NAME_LEN;
            fieldLen = 8;
            try {
                fieldLen = Integer.parseInt( telegramInfo.getProperty(propKey) );
            } catch (Exception e) {}
            return fieldLen + 16;
            
        default:
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        try {
            fieldLen = Integer.parseInt( telegramInfo.getProperty(propKey) );

        } catch (Exception e) {
        	if ( propKey.equals(TelegramKeys.FILE_NAME_LEN)) return 8;
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = propKey;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        return fieldLen;
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
            	logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }

            for ( int inx = 0; inx < fldLen; inx++ ){
            	data[inx] = (byte)0x20;
            }

            byte[] src = null;
            switch (idx) {

            case 1:
                // TR 코드
            	src = telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE).getBytes();
                System.arraycopy(src, 0, data, 0, Math.min(src.length, fldLen) );
                break;

            case 3:
                // 기관코드
            	src = telegramInfo.getProperty(TelegramKeys.BANK_CODE).getBytes();
                System.arraycopy(src, 0, data, 0, Math.min(src.length, fldLen) );
                break;
            
            case 7:
                // 파일명
            	src = batchDoc.getBatchMsg().getHeader().getFileName().getBytes();
                System.arraycopy(src, 0, data, 0, Math.min(src.length, fldLen) );
                break;

            case 9:
            	//화일 정보내역. 화일명+화일size+전문바이트수
            	//RECV 0630/0640에서는 서로 교환한 값중 작은 값으로 결정한다.
            	StringBuffer fileInfo = new StringBuffer();
            	fileInfo.append(makeSpace(batchDoc.getBatchMsg().getHeader().getFileName(), getCalculatedLength(7)));
            	fileInfo.append(makeZero(""+batchDoc.getBatchMsg().getBody().getCurFileSize(),12));
            	fileInfo.append(makeZero(""+calculateTelegramSize(), 4));
                System.arraycopy(fileInfo.toString().getBytes(), 0, data, 0, fldLen );
                break;

            default:
                break;
            }

            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private int calculateTelegramSize(){
        int recSize = 200;
        String bizCode = batchDoc.getBatchMsg().getHeader().getBizCode();
        String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
        BatchJobInfoVO bJobInfo = DirInfoManager.getInstance().getFileInfoByDstcd(processCode, bizCode);
        if ( bJobInfo != null && bJobInfo.getFileRecSize() > 0 ){
            recSize = (int)Math.min(bJobInfo.getFileRecSize(), 4000);
        }

        // 0630/0640 전문 길이 ( 공통 + 24  = SEND_LENGTH ) 0320 전문 길이 ( 공통 + 11 + 파일내역  )
        // 그러므로 0320 전문의 길이는 0630/0640 전문 길이에서 파일 내역을 더하고 13을 빼 준다 )
        return (batchDoc.getBatchMsg().getHeader().getSequenceSize() / recSize) * recSize + SEND_LENGTH - 13 - (getCalculatedLength(7) - 8);
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}